# Ogni file di dati contiene le informazioni
# acquisite per un numero di eventi non noto a priori
#
# Ogni evento è descritto da 22 linee all'interno
# del file di dati cosi' formate:
#
# Le linee da 1 a 16 sono riservate ai 16 canali
# Quelle da 1 a 8 corrispondono alle righe da 1 a 8 sul rilevatore
# Quelle da 9 a 16 corrispondono alle colonne da 1 a 8 sul rilevatore
#
# Ogni linea e' costituita da 4 cifre esadecimali
# Prima cifra: numero canale
# Restanti 3 cifre: valore acquisito per il canale
#
# Le linee da 17 a 20 sono riservate al time stamp
# Ogni linea e' costituita da 4 caratteri esadecimali
#
# Le righe 21 e 22 sono riservate al numero progressivo
# che identifica l'evento
# Ogni linea e' costituita da 4 caratteri esadecimali

import sys
from sys import exit
import array as arr
import os

import mysql.connector

# Definizione della funzione per l'inserimento nella tabella events
# del data base grassdb dei dati raccolti per un'evento
def insertEvent (
                acqTimeStamp, \
                eventTimeStamp, \
                eventCounter, \
                channel_00, \
                channel_01, \
                channel_02, \
                channel_03, \
                channel_04, \
                channel_05, \
                channel_06, \
                channel_07, \
                channel_08, \
                channel_09, \
                channel_10, \
                channel_11, \
                channel_12, \
                channel_13, \
                channel_14, \
                channel_15, \
                conn,  \
                cursor \
                ):
	# Viualizza i parametri attuali della funzione
	#print("insertEvent (parameters)")
	#print("acqTimeStamp: ", acqTimeStamp)
	#print("eventTimeStamp: ", eventTimeStamp)
	#print("eventCounter: ", eventCounter)
	#print("channel_00 :", channel_00)
	#print("channel_01 :", channel_01)
	#print("channel_02 :", channel_02)
	#print("channel_03 :", channel_03)
	#print("channel_04 :", channel_04)
	#print("channel_05 :", channel_05)
	#print("channel_06 :", channel_06)
	#print("channel_07 :", channel_07)
	#print("channel_08 :", channel_08)
	#print("channel_09 :", channel_09)
	#print("channel_10 :", channel_10)
	#print("channel_11 :", channel_11)
	#print("channel_12 :", channel_12)
	#print("channel_13 :", channel_13)
	#print("channel_14 :", channel_14)
	#print("channel_15 :", channel_15)
	
	# Compone la stringa dei valori da assegnare ai campi del record
	# da inserire nella tabella events
	value = acqTimeStamp \
	      + "," + \
	      str(eventTimeStamp) \
	      + "," + \
	      str(eventCounter) \
	      + "," + \
	      str(channel_00) \
	      + "," + \
	      str(channel_01) \
	      + "," + \
	      str(channel_02) \
	      + "," + \
	      str(channel_03) \
	      + "," + \
	      str(channel_04) \
	      + "," + \
	      str(channel_05) \
	      + "," + \
	      str(channel_06) \
	      + "," + \
	      str(channel_07) \
	      + "," + \
	      str(channel_08) \
	      + "," + \
	      str(channel_09) \
	      + "," + \
	      str(channel_10) \
	      + "," + \
	      str(channel_11) \
	      + "," + \
	      str(channel_12) \
	      + "," + \
	      str(channel_13) \
	      + "," + \
	      str(channel_14) \
	      + "," + \
	      str(channel_15)

	# Visualizza la stringa appena composta	
	#print ("Value: ", value)

	# Compone la query per l'inserimento del record nella tabella
	# events
	sql = '''
          INSERT INTO grassDB.events( 
                                    acqTimeStamp,
                                    eventTimeStamp,
                                    eventCounter,
                                    channel_00,
                                    channel_01,
                                    channel_02,
                                    channel_03,
                                    channel_04,
                                    channel_05,
                                    channel_06,
                                    channel_07,
                                    channel_08,
                                    channel_09,
                                    channel_10,
                                    channel_11,
                                    channel_12,
                                    channel_13,
                                    channel_14,
                                    channel_15
                                    )
                                    VALUES (''' + value + ")"
    # Visualizza la query appena composta                                 
	#print ("Comando sql: ", sql)
	
	try:
		# Esegue la query
		cursor.execute(sql)
		
		# In caso di successo retituisce 0
		return(0)

	except:		
		# In caso di errore restituisce 1
		print (" -------- Except --------")
		print (sql)
		return(1)

# Definizione della funzione che processa il file dei dati acquisiti
def dataProcessing (fileName):

	global hostAddress
	
	# Stabilisce la connessione con il database grassdb
	conn = mysql.connector.connect(
	                              user='grass', \
	                              password='hemera2022', \
	                              host=hostAddress, \
	                              database='grassdb' \
	                              )

	# Crea un cursore per il database grassdb
	cursor = conn.cursor()
	
	# estrae dal nome del file di input l'istante di inizio 
	# dell'acquisizione in formato datetime
	fileBaseName=  os.path.basename(fileName)
	acqTimeStamp = "'" + \
                   fileBaseName[0:4] + \
	               "-" + \
	               fileBaseName[4:6] + \
	               "-" + \
	               fileBaseName[6:8] + \
	               " " + \
	               fileBaseName[8:10] + \
	               ":" + \
	               fileBaseName[10:12] + \
	               ":" + \
	               fileBaseName[12:14] + \
	               "'"
	
	# Visualizza l'istante di ricezione del file di dati               
	print ("Acquisition time: ", acqTimeStamp)
	
	# Apre il file di dati acquisiti in lettura
	dataFile = open(fileName, "r")

	# Inizializza il contatore delle linee valide (che contengono
	# almeno un carattere visualizzabile)  lette
	# nel file di dati per l'evento corrente
	lineCounter = 0

	# Inizializza la stringa di caratteri che conterra'
	# la sequenza di 16 caratteri esadecimali
	# che codifichera' il time stamp dell'evento corrente
	timeStampStr = ""

	# Inizializza la stringa di caratteri che conterra'
	# la sequenza di 8 caratteri esadecimali
	# che codifica il numero progressivo che identifica
	# l'evento corrente
	eventCounterStr = ""

	# Inizializza l'array di interi che conterrà
	# il valore corrispondente alla codifica esadecimale 
	# dei valori dei 16 canali misurati per ogni evento
	channelArray = arr.array('i', [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0])

	# Legge la prima linea del file di dati
	line = dataFile.readline()

	# Legge una linea dopo l'altra dal file di dati fino all'EOF
	while (line != ""):
		# elimina dalla linea gli eventuali caratteri non visualizzabili 
		line = line.rstrip()

		# Processa esclusivamente le linee significative
		if (len(line) != 0):
			# Se la linea e' una di quelle relative al valore
			# di un canale per l'evento corrente				
			if ((-1 < lineCounter) and (lineCounter < 16)):
				# Estrae i 3 caratteri esadecimali relativi al
				# valore
				line = line[1:4]
			
				# Converte la codifica esadecimale in un valore intero
				channel = int(line, 16)
			
				# Memorizza il valore così ottenuto nell'array
				# di interi che conterrà i valori dei 16 canali
				channelArray[lineCounter] = channel

			# Se la linea e' una di quelle che forma il time stamp
			# dell'evento corrente
			if ((15 < lineCounter) and (lineCounter < 20)):
				# La concatena alle precedenti 		
				timeStampStr = timeStampStr+line
			
			# Se la linea e' una di quelle che forma il valore
			# del contatore associato all'evento corrente
			if ((19 < lineCounter) and (lineCounter < 22)):
				# La concatena alle precedenti
				eventCounterStr = eventCounterStr+line
				
			# Aggiorna il numero delle linee lette dal file di dati
			lineCounter = lineCounter+1
		
			# Se ha terminato di processare l'informazione relativa
			# all'evento corrente
			if (lineCounter == 22):
				# Estrae dall'array i valori dei canali per l'evento
				# corrente
				channel_00 = channelArray[0]
				channel_01 = channelArray[1]
				channel_02 = channelArray[2]
				channel_03 = channelArray[3]
				channel_04 = channelArray[4]
				channel_05 = channelArray[5]
				channel_06 = channelArray[6]
				channel_07 = channelArray[7]
				channel_08 = channelArray[8]
				channel_09 = channelArray[9]
				channel_10 = channelArray[10]
				channel_11 = channelArray[11]
				channel_12 = channelArray[12]
				channel_13 = channelArray[13]
				channel_14 = channelArray[14]
				channel_15 = channelArray[15]
				
				# Converte la stringa esadecimale che codifica il time
				# stamp dell'evento corrente nel corrispondente valore
				# intero
				eventTimeStamp = int(timeStampStr, 16)

				# Concerte la stringa esadecimale che codifica il
				# valore del contatore associato all'evento corrente
				# nel corrispondente valore intero
				eventCounter = int(eventCounterStr, 16)
				
				# Visualizza il valore intero del contatore associato
				# all'evento corrente
				#print ("Event Counter: ",eventCounter)
			
				# Chiama la funzione che inserisce nella tabella events
				# l'informazione relativa all'evento corrente
				sqlInsertOutcome = insertEvent ( \
				            acqTimeStamp, \
				            eventTimeStamp, \
				            eventCounter, \
				            channel_00, \
				            channel_01, \
				            channel_02, \
				            channel_03, \
				            channel_04, \
				            channel_05, \
				            channel_06, \
				            channel_07, \
				            channel_08, \
				            channel_09, \
				            channel_10, \
				            channel_11, \
				            channel_12, \
				            channel_13, \
				            channel_14, \
				            channel_15, \
				            conn, \
				            cursor
				            )
				
				# print ("sqlInsertOutcome: ", sqlInsertOutcome)
				
				# Se l'inserimento non va a buon fine
				if (sqlInsertOutcome == 1):
					# Visualizza un messaggio di errore
					print (acqTimeStamp)
					print (fileName)
					print (" -------- Except --------")

					# Effettua un rollback
					conn.rollback()
					
					# Chiude il file di dati
					dataFile.close()
		
					# Chiude la connessione con il database grassDB
					conn.close()
					
					# Termina l'esecuzione
					sys.exit()
				
				# Reinizializza il contatore delle linee valide (che contengono
				# almeno un carattere visualizzabile)  lette
				# nel file di dati per l'evento corrente
				lineCounter = 0

				# Reinizializza la stringa di caratteri che conterra'
				# la sequenza di 16 caratteri esadecimali
				# che codifica il time stamp dell'evento corrente
				timeStampStr = ""

				# Reinizializza la stringa di caratteri che conterra'
				# la sequenza di 8 caratteri esadecimali
				# che codifica il numero progressivo che identifica
				# l'evento corrente
				eventCounterStr = ""
				
		# Legge la prossima linea dal file di dati
		line = dataFile.readline()
	
	# Chiude il file di dati
	dataFile.close()
	
	# Se tutti gli inserimenti sono andati a buon fine esegue una commit
	conn.commit()
	
	# Chiude la connessione con il database grassDB
	conn.close()
	print ("Events processed: ",eventCounter)
	
##############################################################

# Controllo numero argomenti a linea di comand
if (len(sys.argv) != 3):
	print ("Syntax:")
	print ("dataProcessing <Data file> <Server address>")
	exit (1)

# Estrazione dalla linea di comando il nome del file
fileName = sys.argv[1]

# Estrazione dalla linea di comando l'indirizzo del server mysql
hostAddress = sys.argv[2]

# Chiamata della funzione per il processamento di un 
# file dati
dataProcessing(fileName)

